/**
 * @file
 * Send a checkout request to Affirm API.
 */

(($, Drupal, drupalSettings) => {
  Drupal.behaviors.commerceAffirmCheckout = {
    attach: (context) => {
      if (
        !drupalSettings.commerceAffirm ||
        !drupalSettings.commerceAffirm.checkoutSettings
      ) {
        return;
      }

      const settings = drupalSettings.commerceAffirm;
      function affirmCheckoutOpen() {
        // eslint-disable-next-line no-undef
        affirm.checkout.open();
      }
      function processAffirmForm() {
        // eslint-disable-next-line no-undef
        affirm.checkout(settings.checkoutSettings);
        if (settings.checkoutSettings.metadata.mode === 'redirect') {
          // Submit and redirect to the checkout flow.
          affirmCheckoutOpen();
        } else {
          const $form = $(this);
          const $primaryButton = $form.find(':input.button--primary');
          $form.on('submit.affirm_modal', async (e) => {
            e.preventDefault();
            $primaryButton.prop('disabled', true);
            // Open the modal.
            affirmCheckoutOpen();
          });
        }
      }
      $(once('affirm-processed', 'form.commerce-checkout-flow', context)).each(
        processAffirmForm,
      );
    },
  };
})(jQuery, Drupal, drupalSettings);
